unit jkfStreamEditors;

{  -------------------------------------------------
   jkfStream 1.0

   Copyright (c) 2001 Kim Friis, Friisware.com
   kim@friisware.com

   This software is Freeware and without any
   warranty what so ever. Don't blame me if it
   crashes your computer, burns down your house or
   steals all your friends :-). (You get the picture)
   Please use at own risk.
   ------------------------------------------------}

interface

uses Classes,sysutils,jkfStreams,DsgnIntf,Dialogs,Controls;

type
  TJkfPropertyEditor = class(TClassProperty)
  public
    procedure Edit; override;
    function GetAttributes: TPropertyAttributes; override;
  end;

  TJKFComponentEditor = class(TComponentEditor)
  public
    procedure ExecuteVerb(Index: Integer); override;
    function GetVerb(Index: Integer): string; override;
    function GetVerbCount: Integer; override;
  end;

procedure Register;

implementation

uses JkfEditorForm;

procedure Register;
begin
  RegisterComponents('FriisWare', [TJkfStoredPack]);
  RegisterPropertyEditor(TypeInfo(TJkfPropertyStream),TJkfStoredPack,
                         '',TJkfPropertyEditor);
  RegisterComponentEditor(TJkfStoredPack, TJKFComponentEditor);
end;

{ TJkfPropertyEditor }

procedure TJkfPropertyEditor.Edit;
var
  OD: TOpenDialog;
  Item:TJkfStoredPack;
begin
  OD := TOpenDialog.Create(nil);
  try
    if OD.Execute then begin
      Item := GetComponent(0) as TJkfStoredPack;
      Item.LoadFromFile(OD.FileName);
      Designer.Modified;
    end;
  finally
    OD.Free;
  end;
end;

function TJkfPropertyEditor.GetAttributes: TPropertyAttributes;
begin
  Result := inherited GetAttributes + [paDialog] - [paSubProperties];
end;

{ TJKFComponentEditor }

procedure TJKFComponentEditor.ExecuteVerb(Index: Integer);
var
  OD: TOpenDialog;
begin
  case index of
    0:begin
        with TJKFPakEditor.Create(nil) do begin
          try
            Pak.PackedFile.Assign((Component as TJkfStoredPack).PackedFile);
            if ShowModal = mrOK then begin
              (Component as TJkfStoredPack).PackedFile.Assign(Pak.PackedFile);
            end;
          finally
            Free;
          end;
        end;
      end;
    1:begin
        OD := TOpenDialog.Create(nil);
        try
          if OD.Execute then begin
            TJkfStoredPack(Component).LoadFromFile(OD.FileName);
            Designer.Modified;
          end;
        finally
          OD.Free;
        end;
      end;
    2:begin
        TJkfStoredPack(Component).Clear;
        Designer.Modified;
      end;
  end;
end;

function TJKFComponentEditor.GetVerb(Index: Integer): string;
begin
  case index of
    0:result := '&Open Editor';
    1:result := 'Open &File';
    2:result := '&Clear mem.';
  end;
end;

function TJKFComponentEditor.GetVerbCount: Integer;
begin
  Result := 3;
end;

end.
